class PlasmaSticker : PlasmaBall replaces PlasmaBall {
	Default {
		RenderStyle "Normal";
		Scale 0.5;
		SeeSound "";
		DeathSound "";
	}
	
	// in the absence of working struct literals (or documentation thereof), it's time to do things the dumb way
	// maybe if those troons spent less time erping on discord, it wouldn't be like this
	static const String decalNames[] = {
		"Autistic", "Disagree", "Dislike", "Late", "MATI", "Politisperg", "Powerlevel", "Dumb"
	};
	static const Name spriteNames[] = {
		"KSAU", "KSDA", "KSDL", "KSLA", "KSMA", "KSPO", "KSPL", "KSDU"
	};
	static const Color splatColors[] = {
		0xf067a0, 0xe5293c, 0x1a84ea, 0xf74726, 0x000000, 0xbcbcbc, 0x3bd662, 0xcacaca
	};
	
	int MyType;
	
	override void PostBeginPlay() {
		super.PostBeginPlay();

        MyType = Random(0, sizeof(decalNames) / sizeof(decalNames[0]) - 1);
		
		sprite = GetSpriteIndex(spriteNames[MyType]);
		A_StartSound("stickers/shoot", pitch: Random(10, 20) * 0.05);
	}
	States {
	Spawn:
		#### AA 1;
		Loop;
	iguessihavetodefinethespritesherefirstwhatthefuck:
		KSAU A 1;
		KSDA A 1;
		KSDL A 1;
		KSLA A 1;
		KSMA A 1;
		KSPO A 1;
		KSPL A 1;
		KSDU A 1;
	Death:
		TNT1 A 0 {
             A_SprayDecal("Decal" .. decalNames[MyType]);
             A_SetTranslucent(1, 1);
             A_SetScale(1, 1);
			 A_StartSound("stickers/splat", pitch: 0.5 + Random(5, 10) * 0.1);
			 for (int i = 0; i < 32; i++) {
				 double lat = random(0, 360);
				 double lng = random(0, 360);
				 double vel = random(2, 3);
				 double dx = cos(lng) * cos(lat);
				 double dy = sin(lng) * cos(lat);
				 double dz = sin(lat);
				 A_SpawnParticle(splatColors[MyType], lifetime: 16, size: random(4, 8),
				                 xoff: 16 * dx, yoff: 16 * dy, zoff: 16 * dz,
                                 velx: vel * dx, vely: vel * dy, velz: vel * dz,
								 accelz: -0.25);
			 }
        }
		Stop;
	}
}
